import type { Operation } from "./types.js";
import { action } from "./instructions.js";

export function call<T>(fn: () => Operation<T>): Operation<T> {
  return action(function* (resolve, reject) {
    try {
      resolve(yield* fn());
    } catch (error) {
      reject(error);
    }
  });
}
